var max_slots = 5;

function Save(sloty)
{
	//save faction info
	//save map info
	//save round
	//save player number
	//save settings
	
	var slot = OpenFile("save"+sloty+".sav");

	var theDate=new Date();
	
	var timey = "";
	var year_temp = "";

	if (theDate.getDate() >9)
		timey = ""+theDate.getDate()+"/";
	else
		timey = "0"+theDate.getDate()+"/";

	if (theDate.getMonth() >9)
		timey = timey+theDate.getMonth()+"/";
	else
		timey = timey+"0"+theDate.getMonth()+"/";
	
	year_temp = ""+theDate.getFullYear()

	timey = timey+year_temp.substring(2,4)+", ";

	if (theDate.getHours() >9)
		timey = timey+theDate.getHours()+":";
	else
		timey = timey+"0"+theDate.getHours()+":";

	if (theDate.getMinutes() >9)
		timey = timey+theDate.getMinutes();
	else
		timey = timey+"0"+theDate.getMinutes();

	slot.write("time", timey);

	for (s=0;s<max_factions;s++)
		factions[s].num_areas = 0;
	for (s=0;s<num_areas;s++)
	{
		if (areas[s].owner >-1)
			factions[areas[s].owner].num_areas++;
	}

	//save faction info
	for (s=0;s<max_factions;s++)
	{

		slot.write("fact"+s+"unit_use", factions[s].unit_use);
		slot.write("fact"+s+"name", factions[s].name);
		slot.write("fact"+s+"colour_red", (factions[s].colour).red);
		slot.write("fact"+s+"colour_green", (factions[s].colour).green);
		slot.write("fact"+s+"colour_blue", (factions[s].colour).blue);
		slot.write("fact"+s+"colour_alpha", (factions[s].colour).alpha);
		slot.write("fact"+s+"description", factions[s].description);
		slot.write("fact"+s+"leader", factions[s].leader);
		slot.write("fact"+s+"unit", factions[s].unit);
		slot.write("fact"+s+"pros", factions[s].pros);
		slot.write("fact"+s+"cons", factions[s].cons);
		slot.write("fact"+s+"land", factions[s].land);
		slot.write("fact"+s+"searaid", factions[s].searaid);
		slot.write("fact"+s+"ai", factions[s].ai);
		slot.write("fact"+s+"first_take", factions[s].first_take);
		slot.write("fact"+s+"num_areas", factions[s].num_areas);
		for (a=0;a<max_factions;a++)
		{
			slot.write("fact"+s+"hate"+a, factions[s].hate[a]);
			slot.write("fact"+s+"allied"+a, factions[s].allied[a]);
		}
	}
	//save map info
	for (s=0;s<num_areas;s++)
	{
		slot.write("areas"+s+"owner", areas[s].owner);
		slot.write("areas"+s+"gold", areas[s].gold);
		slot.write("areas"+s+"food", areas[s].food);
		slot.write("areas"+s+"mine", areas[s].mine);
		slot.write("areas"+s+"farm", areas[s].farm);
		slot.write("areas"+s+"tech", areas[s].tech);
		slot.write("areas"+s+"fort", areas[s].fort);
		slot.write("areas"+s+"sold", areas[s].sold);

		slot.write("areas"+s+"gold_l", areas[s].gold_l);
		slot.write("areas"+s+"food_l", areas[s].food_l);
		slot.write("areas"+s+"mine_l", areas[s].mine_l);
		slot.write("areas"+s+"farm_l", areas[s].farm_l);
		slot.write("areas"+s+"tech_l", areas[s].tech_l);
		slot.write("areas"+s+"fort_l", areas[s].fort_l);
		slot.write("areas"+s+"sold_l", areas[s].sold_l);
		
		slot.write("areas"+s+"gold_t", areas[s].gold_t);
		slot.write("areas"+s+"food_t", areas[s].food_t);
		slot.write("areas"+s+"mine_t", areas[s].mine_t);
		slot.write("areas"+s+"farm_t", areas[s].farm_t);
		slot.write("areas"+s+"tech_t", areas[s].tech_t);
		slot.write("areas"+s+"fort_t", areas[s].fort_t);
		slot.write("areas"+s+"sold_t", areas[s].sold_t);

		slot.write("areas"+s+"auto_gold", areas[s].auto_gold);
		slot.write("areas"+s+"auto_food", areas[s].auto_food);
	}


	//save round
	slot.write("g_round", g_round);

	//save player number
	slot.write("g_player", g_player);

	//save prices
	slot.write("g_price", g_price);
	slot.write("g_price_rand", g_price_rand);
	slot.write("g_price_rand_max", g_price_rand_max);

	//save settings
	slot.write("g_settings", g_settings);
	slot.write("g_diff", g_diff);
	slot.write("g_monst", g_monst);
	slot.flush();
	slot.close();
}

function Load(sloty)
{
	var slot = OpenFile("save"+sloty+".sav");
	
	//save faction info
	for (s=0;s<max_factions;s++)
	{
		factions[s].name=slot.read("fact"+s+"name", factions[s].name);
		factions[s].unit_use = slot.read("fact"+s+"unit_use", factions[s].unit_use);
		factions[s].red=slot.read("fact"+s+"colour_red", (factions[s].colour).red);
		factions[s].green=slot.read("fact"+s+"colour_green", (factions[s].colour).green);
		factions[s].blue=slot.read("fact"+s+"colour_blue", (factions[s].colour).blue);
		factions[s].alpha=slot.read("fact"+s+"colour_alpha", (factions[s].colour).alpha);
		
		factions[s].colour = CreateColor(factions[s].red, factions[s].green, factions[s].blue, factions[s].alpha);
		
		factions[s].description=slot.read("fact"+s+"description", factions[s].description);
		factions[s].leader=slot.read("fact"+s+"leader", factions[s].leader);
		factions[s].unit=slot.read("fact"+s+"unit", factions[s].unit);
		factions[s].pros=slot.read("fact"+s+"pros", factions[s].pros);
		factions[s].cons=slot.read("fact"+s+"cons", factions[s].cons);
		factions[s].land=slot.read("fact"+s+"land", factions[s].land);
		factions[s].searaid=slot.read("fact"+s+"searaid", factions[s].searaid);
		factions[s].ai=slot.read("fact"+s+"ai", factions[s].ai);
		factions[s].first_take=slot.read("fact"+s+"first_take", factions[s].first_take);
		factions[s].num_areas=slot.read("fact"+s+"num_areas", factions[s].num_areas);

		for (a=0;a<max_factions;a++)
		{
			factions[s].hate[a]=slot.read("fact"+s+"hate"+a, factions[s].hate[a]);
			factions[s].allied[a]=slot.read("fact"+s+"allied"+a, factions[s].allied[a]);
		}
	}
	//save map info
	for (s=0;s<num_areas;s++)
	{
		areas[s].owner=slot.read("areas"+s+"owner", areas[s].owner);
		areas[s].gold=slot.read("areas"+s+"gold", areas[s].gold);
		areas[s].food=slot.read("areas"+s+"food", areas[s].food);
		areas[s].mine=slot.read("areas"+s+"mine", areas[s].mine);
		areas[s].farm=slot.read("areas"+s+"farm", areas[s].farm);
		areas[s].tech=slot.read("areas"+s+"tech", areas[s].tech);
		areas[s].fort=slot.read("areas"+s+"fort", areas[s].fort);
		areas[s].sold=slot.read("areas"+s+"sold", areas[s].sold);

		areas[s].gold_l=slot.read("areas"+s+"gold_l", areas[s].gold_l);
		areas[s].food_l=slot.read("areas"+s+"food_l", areas[s].food_l);
		areas[s].mine_l=slot.read("areas"+s+"mine_l", areas[s].mine_l);
		areas[s].farm_l=slot.read("areas"+s+"farm_l", areas[s].farm_l);
		areas[s].tech_l=slot.read("areas"+s+"tech_l", areas[s].tech_l);
		areas[s].fort_l=slot.read("areas"+s+"fort_l", areas[s].fort_l);
		areas[s].sold_l=slot.read("areas"+s+"sold_l", areas[s].sold_l);
		
		areas[s].gold_t=slot.read("areas"+s+"gold_t", areas[s].gold_t);
		areas[s].food_t=slot.read("areas"+s+"food_t", areas[s].food_t);
		areas[s].mine_t=slot.read("areas"+s+"mine_t", areas[s].mine_t);
		areas[s].farm_t=slot.read("areas"+s+"farm_t", areas[s].farm_t);
		areas[s].tech_t=slot.read("areas"+s+"tech_t", areas[s].tech_t);
		areas[s].fort_t=slot.read("areas"+s+"fort_t", areas[s].fort_t);
		areas[s].sold_t=slot.read("areas"+s+"sold_t", areas[s].sold_t);

		areas[s].auto_gold=slot.read("areas"+s+"auto_gold", areas[s].auto_gold);
		areas[s].auto_food=slot.read("areas"+s+"auto_food", areas[s].auto_food);
	}


	//save round
	g_round = slot.read("g_round", g_round);

	//save player number
	g_player = slot.read("g_player", g_player);

	//save prices
	g_price = slot.read("g_price", g_price);
	g_price_rand = slot.read("g_price_rand", g_price_rand);
	g_price_rand_max = slot.read("g_price_rand_max", g_price_rand_max);

	//save settings
	g_settings = slot.read("g_settings", g_settings);
	g_diff = slot.read("g_diff", g_diff);
	g_monst = slot.read("g_monst", g_monst);
	
	SetSettings(g_settings);
}


function LoadMenu(px,py)
{
	var times = new Array();
	var tfactions = new Array();
	var num_areas = new Array();
	var slot = OpenFile("saveauto.sav");
	times[-1] = slot.read("time", "d");
	tfactions[-1] = slot.read("g_player", -1);
	if (tfactions[-1] > -1)
		num_areas[-1] = slot.read("fact"+g_player+"num_areas", -1);
	else
		num_areas[-1] = -1;

	for (l=0;l<max_slots;l++)
	{
		slot = OpenFile("save"+l+".sav");
		times[l] = slot.read("time", "d");
		tfactions[l] = slot.read("g_player", -1);
		if (tfactions[l] > -1)
			num_areas[l] = slot.read("fact"+g_player+"num_areas", -1);
		else
			num_areas[l] = -1;
	}


	var images = new Array(5)
	
	images[0] = LoadImage("title2a.png");
	images[1] = LoadImage("title2b.png");
	images[2] = LoadImage("title2c.png");
	images[3] = LoadImage("title2d.png");
	images[4] = LoadImage("title2e.png");

	var frametime = 1000/30;
	var lasttime = GetTime();

	while(AreKeysLeft())
	  GetKey();
	  
	var slotyy = OpenFile("setting");  
	
	var frames = 0;
  var sselection = 0;
	var fade_max = 64;
  
  function LoadFadeOut()
  {
		for (fade=0;fade<fade_max;fade++)
		{
			images[4].blit(px,py);
			images[0].blit(px,py);
			images[1].blit(px,py);
			images[2].blit(px,py);
			images[3].blit(px,py);
				
	//		window2.drawWindow(130,140+py,60,30);
			font.drawText(4,py+130, "Auto Save");
			if (frames%8 <4 || sselection != 0)
			{
				if (num_areas[-1] > -1)
					font.drawText(80,py+130, times[-1]+", "+factions[tfactions[-1]].name+", Areas: "+num_areas[-1]);
				else
					font.drawText(160+30-font.getStringWidth("empty")/2,py+130, "empty");
			}
			for (st=0;st<max_slots;st++)
			{
				if (frames%8 <4 || sselection != st+1)
				{
					if (num_areas[st] > -1)
						font.drawText(80,py+140+st*10, times[st]+" "+factions[tfactions[st]].name+", Areas: "+num_areas[st]);
					else
						font.drawText(160+30-font.getStringWidth("empty")/2,py+140+st*10, "empty");
				}
			}
	
			if (frames%8 <4 || sselection != max_slots+1)
				font.drawText(160-font.getStringWidth("Back")/2,py+140+st*10, "Back");
			
			frames++;
			g_mouse.blit(GetMouseX(),GetMouseY());
			Rectangle(0,0,320,240,CreateColor(0,0,0,fade*(255/fade_max)));
			FlipScreen();
			
			FadeMusic(fade/fade_max);
	
			lasttime = GetTime();
			while(GetTime()-lasttime < frametime);
		}
		FlipScreen();
  }

	while(true)
	{
		images[4].blit(px,py);
		images[0].blit(px,py);
		images[1].blit(px,py);
		images[2].blit(px,py);
		images[3].blit(px,py);
			
//		window2.drawWindow(130,140+py,60,30);
		font.drawText(4,py+130, "Auto Save");
		if (frames%8 <4 || sselection != 0)
		{
			if (num_areas[-1] > -1)
				font.drawText(80,py+130, times[-1]+", "+factions[tfactions[-1]].name+", Areas: "+num_areas[-1]);
			else
				font.drawText(160+30-font.getStringWidth("empty")/2,py+130, "empty");
		}
		for (st=0;st<max_slots;st++)
		{
			if (frames%8 <4 || sselection != st+1)
			{
				if (num_areas[st] > -1)
					font.drawText(80,py+140+st*10, times[st]+" "+factions[tfactions[st]].name+", Areas: "+num_areas[st]);
				else
					font.drawText(160+30-font.getStringWidth("empty")/2,py+140+st*10, "empty");
			}
		}

		if (frames%8 <4 || sselection != max_slots+1)
			font.drawText(160-font.getStringWidth("Back")/2,py+140+st*10, "Back");
		
		frames++;
		g_mouse.blit(GetMouseX(),GetMouseY());
		FlipScreen();

		lasttime = GetTime();
		while(GetTime()-lasttime < frametime);

		while(AreKeysLeft())
		{
			switch (GetKey())
			{
				case KEY_ESCAPE:
				{
					return;
				}
				case KEY_UP:
				{
					if (sselection > 0)
					  sselection--;
					break;
				}
				case KEY_DOWN:
				{
					if (sselection < max_slots+1)
					  sselection++;
					break;
				}
				case KEY_ENTER:
				{
					if (sselection == max_slots+1)
						return;
					else if (sselection ==0)
					{
						if (tfactions[-1] >-1)
						{
							LoadFadeOut();
							StartGame(tfactions[-1], "auto");
							return;
					  }
					}
					else
					{
						if (tfactions[sselection-1] >-1)
						{
							LoadFadeOut();
							StartGame(tfactions[sselection-1], sselection-1);
							return;
					  }
					}
					break;
				}
			}
		}
	
		if (!IsMouseButtonPressed(MOUSE_LEFT))
			ml_pressed = false;

		if (IsMouseButtonPressed(MOUSE_LEFT) && ml_pressed == false)
		{
			ml_pressed = true;
			
			if (IsMouseInBox(80,py+130, 240, 10))
			{
				PlaySound(0);
				if (sselection ==0)
				{
					if (tfactions[-1] >-1)
					{
						LoadFadeOut();
						StartGame(tfactions[-1], "auto");
						return;
				  }
				}
				else
					sselection = 0;
			}
			for (st=0;st<max_slots;st++)
			{
				if (IsMouseInBox(80,py+140+st*10, 240, 10))
				{
					PlaySound(0);
					if (sselection ==st+1)
					{
						if (tfactions[sselection-1] >-1)
						{
							LoadFadeOut();
							StartGame(tfactions[sselection-1], sselection-1);
							return;
					  }
					}
					else
						sselection = st+1;
				}
			}

			if (IsMouseInBox(160-font.getStringWidth("Back")/2,py+140+st*10, font.getStringWidth("Back"), 10))
			{
				PlaySound(0);
				if (sselection == max_slots+1)
					return;
				else
					sselection = max_slots+1;
			}
		}
	}
}