var max_factions = 6;
var factions = new Array();

for (i=0;i<max_factions;i++)
{

	factions[i] = new Object();
	factions[i].ai = 5;//0-defensive 5-very aggressive
	factions[i].hate = new Array(max_factions);
	factions[i].name = "";
	factions[i].first_take = 1;
	factions[i].searaid = 0;
	factions[i].num_areas = 0;
	factions[i].his = "his";
	factions[i].unit_use = 2;
	
	for (j=0;j<max_factions;j++)
		factions[i].hate[j] = i*10+j;
		
	factions[i].allied = new Array(max_factions);
	for (j=0;j<max_factions;j++)
		factions[i].allied[j] = 0;
	//0=netural 1=allied -1=war
}

factions[0].name = "Cecchetto";
factions[0].colour = CreateColor(32,200,128,160);
factions[0].leader = "Captain Bennel";
factions[0].unit = "Cthulhi Pirates";
factions[0].pros = "-Sea Raids\n";
factions[0].cons =  "-Small Land\n";
factions[0].land =  "One";
factions[0].searaid =  true;
factions[0].ai =  3;
factions[0].description = "The Cecchetto are a new force to appear on the three islands, formed by former pirate Captain Bennel who built a base on the western island.  Building up an army, he has taken control of the local area and now looks to expand.";
factions[0].description2 = "Cecchetto's conquest will likely not be a walk in the park.  Taking over the rest of the island will be easy, but expanding onto the main one may be difficult.  Continuous fighting against both the Galinus and Dolcetto factions is to be expected, so it may be best to form some alliances and slowly build up a force for an aggressive assault.  Having a piracy background will allow the Cecchetto to organize raids against any nation that has a sea boundary.  This may prove useful for obtaining funds while building up an assault force.";

factions[1].name = "Galinus";
factions[1].colour = CreateColor(32,32,200,160);
factions[1].leader = "King O'Yuuk";
factions[1].unit = "Shantaks";
factions[1].land =  "Three";
factions[1].pros = "-Quick Attack\n";
factions[1].cons =  "-Few options\n";
factions[1].searaid =  false;
factions[1].ai =  2;
factions[1].description = "The Galinus faction is what remains of the last royal line, led by King O'Yuuk.  While the recent instability of the region has crippled them, Galinus can come back and rebuild their previous kingdom.";
factions[1].description2 = "Galinus' plight is not as bad as it looks.  A quick assault against the Dolcetto while they're occupied with expanding and fending off the attacks from Lairis may be enough to completely wipe them out.  Once Dolcetto is out of the picture, Lairis and Frantig will no doubt be in continuous conflict, making for an easy takeover while they're both busy attacking each other.";

factions[2].name = "Dolcetto";
factions[2].colour = CreateColor(200,32,160,160);
factions[2].leader = "Lady Alba";
factions[2].unit = "Flying Polyps";
factions[2].land =  "Four";
factions[2].pros = "-Rich lands\n";
factions[2].cons =  "-Poor defense\n";
factions[2].ai =  5;
factions[2].description = "Lady Alba and Lord Gryn V were the leaders behind the recent downfall of King O'Yuuk's sovereignty over the rest the islands.  While they succeeded in obtaining sizable kingdoms of their own, they may not be so inclined to hold back aggression against the other.";
factions[2].description2 = "Dolcetto has a great opportunity for expansion, but doing so too quickly will no doubt lead to their undoing.  While Dolcetto is placed in the rich farmland of the lowlands, their lands are not well fortified, and having their armies too spread out will open them up to attack.  Expanding carefully and letting Lairis concentrate on Frantig may give Dolcetto enough time to take care of Galinus, and then continue north.";
factions[2].searaid =  false;
factions[2].his = "her";

factions[3].name = "Lairis";
factions[3].colour = CreateColor(200,200,32,160);
factions[3].leader = "Lord Gryn V";
factions[3].unit = "Bhole";
factions[3].land =  "Four";
factions[3].pros = "-Good wealth\n";
factions[3].cons =  "-Two fronts\n";
factions[3].ai =  5;
factions[3].description = "Lord Gryn V of the Lairis faction was one of those responsible for the uprising against the king and current political climate.  Despite their recent success, there is still much to do.";
factions[3].description2 = "Lairis is placed between a rock to the north and hard place to the south.  To the north the Frantig are in a fortified position and the years of fighting spent between Lord Gryn V and the Frantig will no doubt not stop now, and to the south their once ally the Dolcetto may cause trouble.  To succeed Lairis must fight on one front at a time, striking at the Frantig using raids to starve them out and slowly crippling their defenses until they can take their lands.  Once the Frantig are gone, expansion into the rich Dolcetto lands will be possible.";
factions[3].searaid =  false;

factions[4].name = "Frantig";
factions[4].colour = CreateColor(200,32,32,160);
factions[4].leader = "Prince Jeral";
factions[4].unit = "Gugs";
factions[4].land =  "Four";
factions[4].pros = "-Fortified\n";
factions[4].cons =  "-Poor lands\n";
factions[4].ai =  3;
factions[4].description = "The self proclaimed prince Jeral was once a highwayman who built up fortified hideouts in the northern mountains.  With the fall of the king Frantig has expanded somewhat, but to continue south they have to deal with their long time rival Lairis.";
factions[4].description2 = "Frantig is in a good position to develop into a formidable force.  They have few borders to guard and each is well fortified, but their lands yield few crops and their mines are underdeveloped.  While developing them they will have to deal with the Lairis, and then proceed with the Dolcetto.  It will take time, but they will be able to concentrate on one front at a time unlike the Lairis and Dolcetto.  As for the Cecchetto, both having a similar background may allow an alliance.";
factions[4].searaid =  false;

factions[5].name = "Daemians";
factions[5].colour = CreateColor(0,0,0,96);
factions[5].leader = "King Sophus";
factions[5].unit = "Crawling Ones";
factions[5].land =  "Two";
factions[5].ai =  2;
factions[5].first_take = 0;
factions[5].description = "";
factions[5].description2 = "";
factions[5].searaid =  false;


/*










*/
//hate numbers
factions[0].hate[4] = -2000;
factions[4].hate[0] = -2000;

factions[2].hate[3] = 1500;
factions[3].hate[2] = 1500;

factions[1].hate[2] = 1500;
factions[2].hate[1] = 1500;

factions[2].hate[5] = -1000;
factions[5].hate[2] = -1000;

factions[4].hate[3] = 2000;
factions[3].hate[4] = 2000;


function GetMonster(fact)
{
	if (factions[fact].unit == "Cthulhi Pirates")
		return "cthulhi";
	if (factions[fact].unit == "Shantaks")
		return "shantak";
	if (factions[fact].unit == "Flying Polyps")
		return "polyps";
	if (factions[fact].unit == "Bhole")
		return "bhole";
	if (factions[fact].unit == "Gugs")
		return "gug";
	if (factions[fact].unit == "Crawling Ones")
		return "crawl";
	return "foot";
}	

function ResetUnitUse(gm)
{
	if (g_monst == 1)
	{
		if (g_diff == 0)
			factions[gm].unit_use = 8;
		else if (g_diff == 1)
			factions[gm].unit_use = 4;
		else if (g_diff == 2)
			factions[gm].unit_use = 2;
	}
	else
		factions[gm].unit_use = 0;
}



function AreAllied(faction1, faction2)
{
	if (factions[faction1].allied[faction2] ==1)
		return true;
	return false;
}

function NumEnemyBound(area,st)
{
	var ccount = 0;

	for (ne=0;ne<num_areas;ne++)
	{
		if (areas[ne].owner > -1)
		{
			if (factions[areas[ne].owner].allied[areas[area].owner] == -1 || areas[ne].owner == areas[st].owner)
			{
				ccount++;
			}
		} 
	}

	return ccount;
}

function OfferAid(area,target, gold,food)
{
	factions[areas[area].owner].hate[areas[area].owner]+=-1*gold-food;

	SendGold(gold, target, area);
	SendFood(food, target, area);
}


function ReturnHate(amt)
{
	var string = "";
	if (amt > 7000)
		string = "Loathed";
	else if (amt > 5000)
		string = "Hated";
	else if (amt > 3000)
		string = "Terrible";
	else if (amt > 1000)
		string = "Disliked";
	else if (amt > -1000)
		string = "Neutral";
	else if (amt > -3000)
		string = "Liked";
	else if (amt > -5000)
		string = "Amicable";
	else if (amt > -7000)
		string = "Great";
	else 
		string = "Loved";
	return string;
}

function OfferAlliance(fact1,fact2)
{
	if (fact2 == 5 || fact1 == 5)
		return false;
	
	
	var fcount = 0;
	for (f1=0;f1<max_factions;f1++)
	{
		if (factions[fact2].allied[f1] == 1 && f1 != fact2)
			fcount++;
	}
	if (fcount <2)
	{
		//possible alliance
		if (factions[fact2].hate[fact1] < -1000*(0.5+0.5*Math.random()))
		{
			factions[fact1].allied[fact2] = 1;
			factions[fact2].allied[fact1] = 1;
			return true;
		}
	}
	return false;
}

function OfferCeasefire(fact1,fact2)
{
	if (factions[fact2].allied[fact1] == -1)
	{
		if (factions[fact2].hate[fact1] < 1000*(1.0+0.5*Math.random()))
		{
			factions[fact1].allied[fact2] = 0;
			factions[fact2].allied[fact1] = 0;
			return true;
		}
	}
	return false;
}


function DoDiplomancy(fact)
{
//cancel alliances with no areas:
	for (f=0;f<max_factions;f++)
		factions[f].num_areas=0;
	
	for (s=0;s<num_areas;s++)
	{
		if (areas[s].owner > -1)
			factions[areas[s].owner].num_areas++;
	}

	if (factions[fact].num_areas ==0)
		return;
	
	for (f=0;f<max_factions;f++)
	{
		if (factions[f].num_areas==0)
		{
			factions[fact].allied[f] = 0;
			factions[f].allied[fact] = 0;
		}
	}
	

//break alliances
	for (f=0;f<max_factions;f++)
	{
		if (factions[f].hate[fact] >=2000 && factions[fact].allied[f] == 1)
		{
			factions[fact].allied[f] = 0;
			factions[f].allied[fact] = 0;

			PromptOverDisplay(undefined, undefined, factions[fact].name+" and "+factions[f].name+" have broken their alliance.");
			return;
		}
	}

//look for new allies
	for (f=0;f<max_factions;f++)
	{
		if (factions[f].hate[fact] <=-2000 && factions[f].allied[fact] != 1&& factions[f].num_areas>0)
		{
			if (f != g_player)
			{
				if (OfferAlliance(fact,f)==true)
				{
					PromptOverDisplay(undefined, undefined, factions[fact].name+" has allied with "+factions[f].name+".");
					return;
				}
			}
		}
	}
}

function FactionDes(num)
{
	var bgc = CreateColor(0,94,138,255);
	var lasttime = GetTime();
	ml_pressed = true;


	Rectangle(0,0,320,240, bgc);
	DrawMap();
	
	var top = GrabImage(0,0,320,16)
	var bot = GrabImage(0,240-16-1,320,17)
	var images1 = new Array(16);
	var images2 = new Array(16);
	for (i=0;i<16;i++)
	{
		images1[i] = GrabImage(0,16+i,320,1);
		images2[i] = GrabImage(0,240-16-i-1,320,1);
	}
	
	var colours = new Array(16);
	for (i=0;i<16;i++)
	{
		colours[i] = CreateColor(255,255,255,i*255/16);
	}

	var frames = 0;
	var the_string = factions[num].description+"\n\n\n"+factions[num].description2;
	var scroll_max = -1*font.getStringHeight(the_string, 160);
	var scroll_begin = 220-8;
	var scroll = scroll_begin;

	var fade = 0;
	var fade_max = 64;

	while(true)
	{
		Rectangle(0,0,320,240, bgc);
		DrawMap();
		
		font.drawTextBox(2,2+12+scroll,160,220,0, the_string);

		top.blit(0,0);
		font.drawText(2,2,"Faction: "+factions[num].name);
		bot.blit(0,240-17);
		font.drawText(2,240-10,"Up/Down: Scroll Text");

		for (i=0;i<16;i++)
		{
			images1[i].blitMask(0,16+i,colours[15-i]);
			images2[i].blitMask(0,240-16-i-1,colours[15-i]);
		}

	  if (scroll>scroll_max)
			frames++;
		if (frames%4==0)
		{
			if (!IsKeyPressed(KEY_DOWN) && !IsKeyPressed(KEY_UP))
				scroll--;
		  if (scroll<scroll_max)
		    fade++
		}
		if (fade > 0)
			fade++;
		
		if (!IsMouseButtonPressed(MOUSE_LEFT))
		{
			ml_pressed = false;
		}
		
		if (IsMouseButtonPressed(MOUSE_LEFT) && ml_pressed == false && fade == 0)
		{
			ml_pressed = true;
			fade++;
		}
		
		if (scroll> scroll_max)
		{
			if (IsKeyPressed(KEY_DOWN))
			{
				if (scroll> scroll_max)
					scroll--;
			}
			if (IsKeyPressed(KEY_UP))
			{
				if (scroll < scroll_begin)
					scroll++;
			}
		
			while(AreKeysLeft())
			{
				switch(GetKey())
				{
					case KEY_ESCAPE:
					{
						fade++;
						break;
					}
					case KEY_ENTER:
					{
						fade++;
						break;
					}
				}
			}
		}
		if (fade > 0)
		{
			Rectangle(0,0,320,240,CreateColor(0,0,0,(fade)*255/64));
			FadeMusic(fade/64);
			if (fade > 64)
				return;
		}
		FlipScreen();
		while(GetTime()-lasttime<1000/30);
		lasttime=GetTime();
	}

}


function IsWon()
{
	for (is=0;is<num_areas;is++)
	{
		if (areas[is].owner > -1)
		{
			if (areas[is].owner != g_player && factions[areas[is].owner].allied[g_player] != 1)
				return false;
		}
		else
			return false;
	}
	return true;
}

function IsLost()
{
	for (is=0;is<num_areas;is++)
	{
		if (areas[is].owner == g_player)
			return false;
	}
	return true;
}


function PromptCreatureUse(player, area)
{
	var bgc2 = CreateColor(0,94,138,255);
	var lasttime = GetTime();
	var frametime = 1000/30;
	
	var string = "Use creature? ("+factions[player].unit_use+" left)";

	ml_pressed = true;
	
	var yes = LoadImage("c_yes1.png");
	var no = LoadImage("c_no1.png");
	
	while(true)
	{
		Rectangle(0,0,320,240,bgc);
		DrawMap();
		
		window.drawWindow(16,16,320-192-32+10,240-48);
		
		font.drawTextBox(16,14+18, 320-192-32+10,120,0,string);

		window2.drawWindow(160-yes.width-20, 120-yes.height/2, yes.width, yes.height);
		yes.blit(160-yes.width-20, 120-yes.height/2);

		window2.drawWindow(160+20, 120-no.height/2, no.width, no.height);
		no.blit(160+20, 120-no.height/2);


		DrawRound();
		g_mouse.blit(GetMouseX(),GetMouseY());
		while(GetTime()-lasttime < frametime);
		lasttime= GetTime();
		FlipScreen();

		if (IsMouseButtonPressed(MOUSE_LEFT) && ml_pressed == false)
		{
			ml_pressed = true;

			if (IsMouseInBox(160-yes.width-20, 120-yes.height/2, yes.width, yes.height))
			{
				PlaySound(0);
				return true;
			}
			if (IsMouseInBox(160+20, 120-no.height/2, no.width, no.height))
			{
				PlaySound(0);
				return false;
			}
		}

		if (!IsMouseButtonPressed(MOUSE_LEFT))
			ml_pressed = false;
	}
}